      Subroutine GAMX(NGrid,RA,RB,D1RA,D1RB,F,D1F,FG,ijzy)
      Implicit Real*8(A-H,O-Z)
************************************************************************
*                                                                      *
*  GAM evaluates the exchange part of the GAM and GAMX               *
*        functionals on the grid.                                      *
*                                                                      *
*    OUTPUT:                                                           *
*      F      - Functional values                                      *
*      D1F    - First derivatives with respect to RA, RB, GA, GB       *
*                                                                      *
*    INPUT:                                                            *
*       ijzy - 1 GAM                                                   *
*       ijzy - 2 GAMX                                                *
*                                                                      *
*      RA,B     - Spin densities                                       *
*      D1RA,B   - Spin density gradients                               *
*      NGrid    - number of grid points                                *
*                                                                      *
*  Analytic second derivatives are not available yet!!!                *
*                                                                      *
*  RP (09/12)                                                          *
*                                                                      *
************************************************************************
      Real*8 RA(*),RB(*),D1RA(NGrid,3),D1RB(NGrid,3),F(*),D1F(NGrid,*)
      Integer dRA, dRB, dGA, dGB
      Save One,Two,Three,Four,Five,Six,Seven,Eight,Nine
      Data One/1.0d0/,Two/2.0d0/,Three/3.0d0/,Four/4.0d0/,Five/5.0d0/,
     $  Six/6.0d0/,Seven/7.0d0/,Eight/8.0d0/,Nine/9.0d0/
C
      dRA = 1
      dRB = 2
      dGA = 3
      dGB = 4
C
      TinyDFT = 1.0d-8
      G    = 0.004d+0
      ome  = 2.5d+0        
      If (ijzy.eq.1) then
c
c      GAM
c      
       CC00 =  1.32730461D+00
       CC01 =  0.88610229D+00
       CC02 =  -5.7383319D+00
       CC03 =  8.6019682D+00
c
       CC10 =  -7.860183D-01
       CC11 =  -4.7878692D+00
       CC12 =  3.9098909D+00
       CC13 =  -2.1161097D+00
c
       CC20 =  0.80257545D+00
       CC21 =  14.4364076D+00
       CC22 =  8.42735029D+00
       CC23 =  -6.2155264D+00
c
       CC30 =  -0.1423312D+00
       CC31 =  -13.459836D+00
       CC32 =  1.52354748D+00
       CC33 =  -10.052992D+00

      Else If (ijzy.eq.2) then
c
c      GAMX 
c      
       CC00 =  1.32730461D+00
       CC01 =  0.88610229D+00
       CC02 =  -5.7383319D+00
       CC03 =  8.6019682D+00
c
       CC10 =  -7.860183D-01
       CC11 =  -4.7878692D+00
       CC12 =  3.9098909D+00
       CC13 =  -2.1161097D+00
c
       CC20 =  0.80257545D+00
       CC21 =  14.4364076D+00
       CC22 =  8.42735029D+00
       CC23 =  -6.2155264D+00
c       
       CC30 =  -0.1423312D+00
       CC31 =  -13.459836D+00
       CC32 =  1.52354748D+00
       CC33 =  -10.052992D+00

      End If
      F12   = Two * Six
      F24   = Four * Six
      F28   = Four * Seven
      F2o3  = Two / Three
      F3o2  = Three / Two
      F1o3  = One / Three
      F4o3  = Four / Three
      F7o3  = Seven / Three
      F8o3  = Eight / Three
      F10o3 = F2o3 * Five
      F28o9 = F28 / Nine
      Pi    = ACos(-One)
C
      Ax = -F3o2*(F4o3*PI)**(-F1o3)
C
C     Alpha contributions ...
C
      Do 10 iG = 1, NGrid
        If(RA(iG).gt.TinyDFT) then
          pX    = RA(iG)
          GamX2 = D1RA(iG,1)**2 + D1RA(iG,2)**2 + D1RA(iG,3)**2
          S2    = GamX2*pX**(-F8o3)
          U     = G*S2/(One+G*S2)
          E     = Ax*pX**F4o3
          FV    = ome*pX**F1o3/(One+ome*pX**F1o3)
c
       FGAM =CC00  +CC01      *U+CC02      *U**2+CC03      *U**3+
     $    CC10*FV   +CC11*FV   *U+CC12*FV   *U**2+CC13*FV   *U**3+
     $    CC20*FV**2+CC21*FV**2*U+CC22*FV**2*U**2+CC23*FV**2*U**3+
     $    CC30*FV**3+CC31*FV**3*U+CC32*FV**3*U**2+CC33*FV**3*U**3
c
          F(iG) = F(iG) + E*FGAM
c
c First Derivative
c
          ER = F4o3*E/pX
          S    = Sqrt(S2)
          GamX = Sqrt(GamX2)
          SR   = -F4o3*S/pX
          SG   = S/GamX
          US   = Two*G*S/((One+G*S*S)**2)
c        
          dFVdR =  (ome/(Three*pX**F2o3))
     $                *(One+ome*pX**F1o3)**(-Two)
c
        dFGAMdU=CC01+2.0d0*CC02      *U+3.0d0*CC03      *U**2+
     $     CC11*FV   +2.0d0*CC12*FV   *U+3.0d0*CC13*FV   *U**2+
     $     CC21*FV**2+2.0d0*CC22*FV**2*U+3.0d0*CC23*FV**2*U**2+
     $     CC31*FV**3+2.0d0*CC32*FV**3*U+3.0d0*CC33*FV**3*U**2
        dFGAMdV=
     $     CC10+CC11   *U+CC12   *U**2+CC13   *U**3+
     $     2.0d0*CC20*FV   +2.0d0*CC21*FV*U+
     $     2.0d0*CC22*FV*U**2+2.0d0*CC23*FV*U**3+
     $     3.0d0*CC30*FV**2+3.0d0*CC31*FV**2*U+
     $     3.0d0*CC32*FV**2*U**2+3.0d0*CC33*FV**2*U**3
c
        dFGAMdR  = dFGAMdU*US*SR+dFGAMdV*dFVdR
        dFGAMdG  = dFGAMdU*US*SG
c
            D1F(iG,dRA) = D1F(iG,dRA) + ER*FGAM
     $                      + E*dFGAMdR
            D1F(iG,dGA) = D1F(iG,dGA) + E*dFGAMdG/(Two*GamX)
          endIf
   10   Continue
C
C     Beta contributions ...
C
      Do 20 iG = 1, NGrid
        If(RB(iG).gt.TinyDFT) then
          pX    = RB(iG)
          GamX2 = D1RB(iG,1)**2 + D1RB(iG,2)**2 + D1RB(iG,3)**2
          S2    = GamX2*pX**(-F8o3)
          U     = G*S2/(One+G*S2)
          E     = Ax*pX**F4o3
          FV    = ome*pX**F1o3/(One+ome*pX**F1o3)
c
       FGAM =CC00  +CC01      *U+CC02      *U**2+CC03      *U**3+
     $    CC10*FV   +CC11*FV   *U+CC12*FV   *U**2+CC13*FV   *U**3+
     $    CC20*FV**2+CC21*FV**2*U+CC22*FV**2*U**2+CC23*FV**2*U**3+
     $    CC30*FV**3+CC31*FV**3*U+CC32*FV**3*U**2+CC33*FV**3*U**3
c
          F(iG) = F(iG) + E*FGAM
c
c First Derivative
c
          ER = F4o3*E/pX
          S    = Sqrt(S2)
          GamX = Sqrt(GamX2)
          SR   = -F4o3*S/pX
          SG   = S/GamX
          US   = Two*G*S/((One+G*S*S)**2)
c        
          dFVdR =  (ome/(Three*pX**F2o3))
     $                *(One+ome*pX**F1o3)**(-Two)
c
        dFGAMdU=CC01+2.0d0*CC02      *U+3.0d0*CC03      *U**2+
     $     CC11*FV   +2.0d0*CC12*FV   *U+3.0d0*CC13*FV   *U**2+
     $     CC21*FV**2+2.0d0*CC22*FV**2*U+3.0d0*CC23*FV**2*U**2+
     $     CC31*FV**3+2.0d0*CC32*FV**3*U+3.0d0*CC33*FV**3*U**2
c
        dFGAMdV=
     $     CC10+CC11   *U+CC12   *U**2+CC13   *U**3+
     $     2.0d0*CC20*FV   +2.0d0*CC21*FV*U+
     $     2.0d0*CC22*FV*U**2+2.0d0*CC23*FV*U**3+
     $     3.0d0*CC30*FV**2+3.0d0*CC31*FV**2*U+
     $     3.0d0*CC32*FV**2*U**2+3.0d0*CC33*FV**2*U**3
c
        dFGAMdR  = dFGAMdU*US*SR+dFGAMdV*dFVdR
        dFGAMdG  = dFGAMdU*US*SG
c
            D1F(iG,dRB) = D1F(iG,dRB) + ER*FGAM
     $                      + E*dFGAMdR
            D1F(iG,dGB) = D1F(iG,dGB) + E*dFGAMdG/(Two*GamX)
          endIf
   20   Continue
      Return
      End